hdu 2795 线段树(二维问题一维化)

Billboard

Time Limit: 20000/8000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 10961    Accepted Submission(s): 4863

Problem Description

At the entrance to the university, there is a huge rectangular billboard of size h*w (h is its height and w is its width). The board is the place where all possible announcements are posted: nearest programming competitions, changes in the dining room menu, and other important information.

On September 1, the billboard was empty. One by one, the announcements started being put on the billboard.

Each announcement is a stripe of paper of unit height. More specifically, the i-th announcement is a rectangle of size 1 * wi.

When someone puts a new announcement on the billboard, she would always choose the topmost possible position for the announcement. Among all possible topmost positions she would always choose the leftmost one.

If there is no valid location for a new announcement, it is not put on the billboard (that‘s why some programming contests have no participants from this university).

Given the sizes of the billboard and the announcements, your task is to find the numbers of rows in which the announcements are placed.

Input

There are multiple cases (no more than 40 cases).

The first line of the input file contains three integer numbers, h, w, and n (1 <= h,w <= 10^9; 1 <= n <= 200,000) - the dimensions of the billboard and the number of announcements.

Each of the next n lines contains an integer number wi (1 <= wi <= 10^9) - the width of i-th announcement.

Output

For each announcement (in the order they are given in the input file) output one number - the number of the row in which this announcement is placed. Rows are numbered from 1 to h, starting with the top row. If an announcement can‘t be put on the billboard, output "-1" for this announcement.

Sample Input

3 5 5 2 4 3 3 3

Sample Output

1 2 1 3 -1

Author

[email protected]

Source

HDOJ 2009 Summer Exercise(5)

这道题的大意是指在一个高为h,宽为w的广告牌上贴广告,告诉你广告的长都为1,宽度不确定,要你输出广告所粘贴的位置。如果所给的广告不能贴在广告牌上,就输出-1.

这道题中,由于广告的长度都是确定的,那么在考虑广告能否贴在广告牌上时可以忽略起长度,以宽度作为标准来确定其是否能被贴上去。然后在利用线段树就可以解答了。

AC代码:

#include<stdio.h>
#include<string.h>
struct
{
 int a,b;
 int flag;
 int room;
}t[800060];
int h,w,n;
void make(int x,int y,int num)
{
 t[num].a=x;
 t[num].b=y;
 t[num].room=w;.//一开始误会了,还以为宽度可以累加,其实不论高度是多少,宽度总是一定的。
 if(x==y)
  return;
 make(x,(x+y)/2,num*2);
 make((x+y)/2+1,y,num*2+1);
}
int insert(int num,int space)
{
 if(t[num].a==t[num].b)
 {

t[num].room-=space;
  return t[num].a;
 }
 int ans;
 if(t[num*2].room>=space)
  ans=insert(num*2,space);
 else if(t[num*2+1].room>=space)
  ans=insert(num*2+1,space);
 t[num].room=t[num*2].room>t[num*2+1].room?t[num*2].room:t[num*2+1].room;//在一个高度范围内,其所能容纳的广告的宽度为其孩子节点中的最大宽度。
 return ans;
}
int main()

 int i,o,res;
 while(scanf("%d%d%d",&h,&w,&n)!=EOF)
 {
  if(h>n)
   h=n;
  res=0;
  make(1,h,1);
  for(i=1;i<=n;i++)
  {
   scanf("%d",&o);
   if(t[1].room<o)
    printf("-1\n");
   else
   {
    res=insert(1,o);
    printf("%d\n",res);
   }
  }
 }
 return 0;
}

hdu 2795 线段树(二维问题一维化)

时间: 2024-10-21 09:09:23

hdu 2795 线段树(二维问题一维化)的相关文章

hdu 2795 线段树--点更新

http://acm.hdu.edu.cn/showproblem.php?pid=2795 多校的第一场和第三场都出现了线段树,比赛期间没做,,这两天先做几道热身下,然后31号之前把那两道多校的线段树都搞了,这是一道热身题 关键是建模: 首先一定看清楚题目构造的场景,看有什么特点--------会发现,如果尽量往左上放置的话,那么由于 the i-th announcement is a rectangle of size 1 * wi.,完全可以对h建立线段树,表示一行,结点里的l,r就表示

HDU 2795 线段树(转变思维方能改变世界)

Billboard Time Limit: 20000/8000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 9895    Accepted Submission(s): 4413 Problem Description At the entrance to the university, there is a huge rectangular billboard of si

HDU6638 Snowy Smile (线段树+二维最大子段和)

2019杭电多校第六场的一道签到题 这次我们显然要求的二维矩阵的最大值,分析题目我们可以得到几个细节. 1.首先数据很大,肯定要离散化. 2.离散化后,我们想象有很多点在一个平面内,要统计矩阵最大值 3.我们之前接触过如何求一条线上的最大子段和,只要用线段树维护四个值就能够解决 4.根据已知,我们发现求矩阵和也是可以这么做的,因为他是一个矩形,所以我们假如我们有两行,其实可以把第二行的对应数据加到第一行上去,进行压维操作,再求一维的最大子段和. 5.我们要考虑所有的情况,因此我们以x轴作为线段树

CF1321-World of Darkraft: Battle for Azathoth (线段树+二维偏序)

题意: 题目大致意思是给你n把武器,m件防具,p个怪兽,接下来n行每行告诉你该武器的攻击力和花费, 接下来m行告诉你该防具的防御力和花费,然后p行每行告诉你这个怪兽的攻击力,防御力以及打败这个 怪兽可以获得的金钱数,当你的攻击力大于怪兽的防御力,并且你的防御力大于怪兽的攻击力时,你可 以打败这个怪兽.你必须至少购买1件武器和1件防具,问你最多可以获得多少钱. 链接:https://codeforces.com/contest/1321/problem/E 思路: 看了大神的题解,第一次知道二维偏

HDU 2795 线段树单点更新

Billboard Time Limit: 20000/8000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 23498    Accepted Submission(s): 9687 Problem Description At the entrance to the university, there is a huge rectangular billboard of s

hdu 2795 线段树(纵向)

注意h的范围和n的范围,纵向建立线段树 题意:h*w的木板,放进一些1*L的物品,求每次放空间能容纳且最上边的位子思路:每次找到最大值的位子,然后减去L线段树功能:query:区间求最大值的位子(直接把update的操作在query里做了)3 5 524333 1213-1 1 #include<cstdio> 2 #include<iostream> 3 #include<algorithm> 4 #include<cstring> 5 #include&

HDU 2795 (线段树 单点更新) Billboard

h*w的木板,放进一些1*L的物品,求每次放空间能容纳且最上边的位子. 每次找能放纸条而且是最上面的位置,询问完以后可以同时更新,所以可以把update和query写在同一个函数里. 1 #include <cstdio> 2 #include <cstring> 3 #include <algorithm> 4 using namespace std; 5 6 const int maxn = 200000 + 10; 7 8 int _max[maxn <&l

Max Sum Plus Plus HDU - 1024 基础dp 二维变一维的过程,有点难想

/* dp[i][j]=max(dp[i][j-1]+a[j],max(dp[i-1][k])+a[j]) (0<k<j) dp[i][j-1]+a[j]表示的是前j-1分成i组,第j个必须放在前一组里面. max( dp[i-1][k] ) + a[j] )表示的前(0<k<j)分成i-1组,第j个单独分成一组. */ #include <iostream> #include <cstdio> #include <cstring> #inclu

UVa 11992 Fast Matrix Operations(线段树双懒操作,二维转一维)

题意:给个r*c的矩形,三种操作,将一个子矩形权值+v,将一个子矩阵权值赋值为v,查询一个子矩阵sum,max,min.起初矩阵权值为0,保证r<=20,r*c<=1e6,操作次数不超过10000 链接: http://acm.hust.edu.cn/vjudge/problem/viewProblem.action?id=18697 题解:将二维转一维,设当前点为(x,y),则它在线段树上的点为(x-1)*c+y,由于行不超过20行,不妨枚举每一行,去操作.对于一维的线段树,要进行赋值,加法